## ros-rolling-rcutils 5.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rcutils)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

include(CheckLibraryExists)

find_package(ament_cmake_python REQUIRED)
find_package(ament_cmake_ros REQUIRED)

find_package(Python3 REQUIRED COMPONENTS Interpreter)

ament_python_install_package(${PROJECT_NAME})

if(UNIX AND NOT APPLE)
  include(cmake/check_c_compiler_uses_glibc.cmake)
  check_c_compiler_uses_glibc(USES_GLIBC)
  if(USES_GLIBC)
    # Ensure GNU extended libc API is used, as C++ test code will.
    # See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=2082.
    add_definitions(-D_GNU_SOURCE)
  endif()
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # enables building a static library but later link it into a dynamic library
  add_compile_options(-fPIC)
endif()
if(NOT WIN32)
  # About -Wno-sign-conversion: With Clang, -Wconversion implies -Wsign-conversion. There are a number of
  # implicit sign conversions in gtest.cc, see https://ci.ros2.org/job/ci_osx/9381/clang/.
  # Hence disabling -Wsign-conversion for now until all those have eventually been fixed.
  # (from https://github.com/ros2/rcutils/pull/263#issuecomment-663252537)
  add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wpedantic)
endif()

if(WIN32)
  set(time_impl_c src/time_win32.c)
else()
  set(time_impl_c src/time_unix.c)
endif()

set(rcutils_sources
  src/allocator.c
  src/array_list.c
  src/char_array.c
  src/cmdline_parser.c
  src/env.c
  src/error_handling.c
  src/filesystem.c
  src/find.c
  src/format_string.c
  src/hash_map.c
  src/logging.c
  src/process.c
  src/qsort.c
  src/repl_str.c
  src/shared_library.c
  src/snprintf.c
  src/split.c
  src/strcasecmp.c
  src/strdup.c
  src/strerror.c
  src/string_array.c
  src/string_map.c
  src/testing/fault_injection.c
  src/time.c
  ${time_impl_c}
  src/uint8_array.c
)
set_source_files_properties(
  ${rcutils_sources}
  PROPERTIES language "C")

# "watch" template/inputs for changes
configure_file(
  "resource/logging_macros.h.em"
  "logging_macros.h.em.watch"
  COPYONLY)
configure_file(
  "rcutils/logging.py"
  "logging.py.watch"
  COPYONLY)
# generate header with logging macros
set(rcutils_module_path ${CMAKE_CURRENT_SOURCE_DIR})
set(python_code
  "import em"  # implicitly added ; between python statements due to CMake list
  "\
em.invoke( \
  [ \
    '-o', 'include/rcutils/logging_macros.h', \
    '-D', 'rcutils_module_path=\"${rcutils_module_path}\"', \
    '${CMAKE_CURRENT_SOURCE_DIR}/resource/logging_macros.h.em' \
  ] \
)")
string(REPLACE ";" "$<SEMICOLON>" python_code "${python_code}")
add_custom_command(OUTPUT include/rcutils/logging_macros.h
  COMMAND ${CMAKE_COMMAND} -E make_directory "include/rcutils"
  COMMAND Python3::Interpreter ARGS -c "${python_code}"
  DEPENDS
    "${CMAKE_CURRENT_BINARY_DIR}/logging_macros.h.em.watch"
    "${CMAKE_CURRENT_BINARY_DIR}/logging.py.watch"
  COMMENT "Expanding logging_macros.h.em"
  VERBATIM
)
list(APPEND rcutils_sources
  include/rcutils/logging_macros.h)

add_library(
  ${PROJECT_NAME}
  ${rcutils_sources})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCUTILS_BUILDING_DLL")

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

target_link_libraries(${PROJECT_NAME} ${CMAKE_DL_LIBS})

# Needed if pthread is used for thread local storage.
if(IOS AND IOS_SDK_VERSION LESS 10.0)
  ament_export_libraries(pthread)
endif()

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  if(NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
  endif()

  find_package(performance_test_fixture REQUIRED)

  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_pytest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(launch_testing_ament_cmake REQUIRED)

  check_library_exists(atomic __atomic_load_8 "" HAVE_LIBATOMICS)

  if(HAVE_LIBATOMICS AND NOT WIN32)
    # Exporting link flag since it won't pass ament_export_libraries() existance check
    ament_export_link_flags("-latomic")
  endif()

  if(ament_cmake_cppcheck_FOUND)
    ament_cppcheck(
      TESTNAME "cppcheck_logging_macros"
      "${CMAKE_CURRENT_BINARY_DIR}/include/rcutils/logging_macros.h")
  endif()
  if(ament_cmake_cpplint_FOUND)
    ament_cpplint(
      TESTNAME "cpplint_logging_macros"
      # the generated code might contain longer lines for templated types
      MAX_LINE_LENGTH 999
      ROOT "${CMAKE_CURRENT_BINARY_DIR}/include"
      "${CMAKE_CURRENT_BINARY_DIR}/include/rcutils/logging_macros.h")
  endif()
  if(ament_cmake_uncrustify_FOUND)
    ament_uncrustify(
      TESTNAME "uncrustify_logging_macros"
      # the generated code might contain longer lines for templated types
      MAX_LINE_LENGTH 0
      "${CMAKE_CURRENT_BINARY_DIR}/include/rcutils/logging_macros.h")
  endif()

  find_package(mimick_vendor REQUIRED)

  find_package(osrf_testing_tools_cpp REQUIRED)
  get_target_property(memory_tools_test_env_vars
    osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)
  get_target_property(memory_tools_is_available
    osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_IS_AVAILABLE)

  ament_add_gtest(test_logging test/test_logging.cpp)
  target_link_libraries(test_logging ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools)

  add_executable(test_logging_long_messages test/test_logging_long_messages.cpp)
  target_link_libraries(test_logging_long_messages ${PROJECT_NAME})
  add_launch_test(
    "test/test_logging_long_messages.py"
    TARGET test_logging_long_messages
    WORKING_DIRECTORY "$<TARGET_FILE_DIR:test_logging_long_messages>"
    TIMEOUT 10
  )

  add_launch_test(
    "test/test_logging_output_format.py"
    TARGET test_logging_output_format
    WORKING_DIRECTORY "$<TARGET_FILE_DIR:test_logging_long_messages>"
    TIMEOUT 10
  )

  ament_add_gmock(test_logging_macros test/test_logging_macros.cpp)
  target_link_libraries(test_logging_macros ${PROJECT_NAME})

  add_executable(test_logging_macros_c test/test_logging_macros.c)
  target_link_libraries(test_logging_macros_c ${PROJECT_NAME})
  ament_add_test(test_logging_macros_c
    COMMAND "$<TARGET_FILE:test_logging_macros_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO)

  set(SKIP_MEMORY_TOOLS_TEST "")
  if(NOT memory_tools_is_available)
    set(SKIP_MEMORY_TOOLS_TEST "SKIP_TEST")
  endif()

  macro(rcutils_custom_add_gtest target)
    ament_add_gtest(${target} ${ARGN})
  endmacro()

  macro(rcutils_custom_add_gmock target)
    ament_add_gmock(${target} ${ARGN})
  endmacro()

  # Gtests
  rcutils_custom_add_gtest(test_allocator test/test_allocator.cpp
    ENV ${memory_tools_test_env_vars}
    ${SKIP_MEMORY_TOOLS_TEST}
  )
  if(TARGET test_allocator)
    target_link_libraries(test_allocator ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
  endif()

  rcutils_custom_add_gtest(test_char_array
    test/test_char_array.cpp
  )
  if(TARGET test_char_array)
    target_link_libraries(test_char_array ${PROJECT_NAME} mimick)
  endif()

  # Can't use C++ with stdatomic_helper.h
  add_executable(test_atomics_executable
    test/test_atomics.c
  )
  set_target_properties(test_atomics_executable
    PROPERTIES
      LANGUAGE C
  )
  target_link_libraries(test_atomics_executable ${PROJECT_NAME})
  if(HAVE_LIBATOMICS)
    target_link_libraries(test_atomics_executable atomic)
  endif()

  add_test(NAME test_atomics COMMAND test_atomics_executable)

  rcutils_custom_add_gmock(test_error_handling test/test_error_handling.cpp
    # Append the directory of librcutils so it is found at test time.
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
    ENV ${memory_tools_test_env_vars}
  )
  if(TARGET test_error_handling)
    target_link_libraries(test_error_handling ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
  endif()

  rcutils_custom_add_gmock(test_error_handling_helpers test/test_error_handling_helpers.cpp
    # Append the directory of librcutils so it is found at test time.
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
    ENV ${memory_tools_test_env_vars}
  )
  if(TARGET test_error_handling_helpers)
    target_include_directories(test_error_handling_helpers PUBLIC include)
    target_link_libraries(test_error_handling_helpers osrf_testing_tools_cpp::memory_tools)
  endif()

  rcutils_custom_add_gtest(test_split
    test/test_split.cpp
  )
  if(TARGET test_split)
    target_link_libraries(test_split ${PROJECT_NAME} mimick)
  endif()

  rcutils_custom_add_gtest(test_find
    test/test_find.cpp
  )
  if(TARGET test_find)
    target_link_libraries(test_find ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_strerror
    test/test_strerror.cpp
  )
  if(TARGET test_strerror)
    target_link_libraries(test_strerror ${PROJECT_NAME} mimick)
  endif()

  rcutils_custom_add_gtest(test_string_array
    test/test_string_array.cpp
  )
  if(TARGET test_string_array)
    target_link_libraries(test_string_array ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_env test/test_env.cpp
    ENV
      EMPTY_TEST=
      NORMAL_TEST=foo
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
  )
  if(TARGET test_env)
    target_link_libraries(test_env ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_filesystem
    test/test_filesystem.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_filesystem)
    ament_target_dependencies(test_filesystem "osrf_testing_tools_cpp")
    target_link_libraries(test_filesystem ${PROJECT_NAME} mimick)
    target_compile_definitions(test_filesystem PRIVATE BUILD_DIR="${CMAKE_CURRENT_BINARY_DIR}")
  endif()

  rcutils_custom_add_gtest(test_strdup
    test/test_strdup.cpp
  )
  if(TARGET test_strdup)
    target_link_libraries(test_strdup ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_format_string
    test/test_format_string.cpp
  )
  if(TARGET test_format_string)
    target_link_libraries(test_format_string ${PROJECT_NAME} mimick)
  endif()

  rcutils_custom_add_gtest(test_string_map
    test/test_string_map.cpp
  )
  if(TARGET test_string_map)
    ament_target_dependencies(test_string_map "osrf_testing_tools_cpp")
    target_link_libraries(test_string_map ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_isalnum_no_locale
    test/test_isalnum_no_locale.cpp
  )
  if(TARGET test_isalnum_no_locale)
    target_link_libraries(test_isalnum_no_locale ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_repl_str
    test/test_repl_str.cpp
  )
  if(TARGET test_repl_str)
    target_link_libraries(test_repl_str ${PROJECT_NAME})
  endif()

  macro(add_dummy_shared_library target)
    add_library(${target} test/dummy_shared_library/dummy_shared_library.c)
    if(WIN32)
      # Causes the visibility macros to use dllexport rather than dllimport
      # which is appropriate when building the dll but not consuming it.
      target_compile_definitions(${target} PRIVATE "DUMMY_SHARED_LIBRARY_BUILDING_DLL")
    endif()
  endmacro()

  ament_add_gtest(test_shared_library_in_run_paths test/test_shared_library.cpp)
  if(TARGET test_shared_library_in_run_paths)
    # Rely on CMake setting build tree RUNPATHs by default on Unix systems.
    add_dummy_shared_library(dummy_shared_library_in_run_paths)

=== debian/changelog ===
ros-rolling-rcutils (5.0.1-1focal) focal; urgency=high

  * Use static_cast instead of C-style cast (#349 <https://github.com/ros2/rcutils/issues/349>)
  * Contributors: Jacob Perron

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 14 Jan 2022 08:00:00 -0000

ros-rolling-rcutils (5.0.0-1focal) focal; urgency=high

  * Fixing up documentation build when using rosdoc2 (#344 <https://github.com/ros2/rcutils/issues/344>)
  * Stop double-defining structs. (#333 <https://github.com/ros2/rcutils/issues/333>)
  * Use FindPython3 explicitly instead of FindPythonInterp implicitly (#345 <https://github.com/ros2/rcutils/issues/345>)
  * Fix build on Android (#342 <https://github.com/ros2/rcutils/issues/342>)
  * Deprecate get_env.h and move content to env.{h,c} (#340 <https://github.com/ros2/rcutils/issues/340>)
  * Contributors: Chris Lalancette, Christophe Bedard, Ivan Santiago Paunovic, Shane Loretz, William Woodall

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 01 Nov 2021 07:00:00 -0000

ros-rolling-rcutils (4.0.2-1focal) focal; urgency=high

  * Declare dependency on libatomic (#338 <https://github.com/ros2/rcutils/issues/338>)
  * Contributors: Scott K Logan

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 12 Apr 2021 07:00:00 -0000

ros-rolling-rcutils (4.0.1-1focal) focal; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#335 <https://github.com/ros2/rcutils/issues/335>)
  * Contributors: shonigmann

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 06 Apr 2021 07:00:00 -0000

ros-rolling-rcutils (4.0.0-1focal) focal; urgency=high

  * Quiet down a warning in release mode. (#334 <https://github.com/ros2/rcutils/issues/334>)
  * Make the logging separate char an implementation detail. (#332 <https://github.com/ros2/rcutils/issues/332>)
  * Performance tests demo (#288 <https://github.com/ros2/rcutils/issues/288>)
  * Remove references of __xstat (#330 <https://github.com/ros2/rcutils/issues/330>)
  * Update the documentation to be more consistent. (#331 <https://github.com/ros2/rcutils/issues/331>)
  * Shorten some excessively long lines of CMake (#328 <https://github.com/ros2/rcutils/issues/328>)
  * qnx-support: include sys/link.h & avoid using dlinfo (#327 <https://github.com/ros2/rcutils/issues/327>)
  * QNX uses XSI-compliant (#326 <https://github.com/ros2/rcutils/issues/326>)
  * Contributors: Ahmed Sobhy, Chris Lalancette, Homalozoa X, Jorge Perez, Scott K Logan

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 18 Mar 2021 07:00:00 -0000

ros-rolling-rcutils (3.1.0-1focal) focal; urgency=high

  * Add an API for directory iteration (#323 <https://github.com/ros2/rcutils/issues/323>)
  * Fix a leak during error handling in dir size calculation (#324 <https://github.com/ros2/rcutils/issues/324>)
  * Fix rcutils_shared_library_t path on Windows. (#322 <https://github.com/ros2/rcutils/issues/322>)
  * Check linker flags instead of assuming compiler correlation. (#321 <https://github.com/ros2/rcutils/issues/321>)
  * Improve shared library relative paths handling (#320 <https://github.com/ros2/rcutils/issues/320>)
  * Contributors: Michel Hidalgo, Scott K Logan

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 25 Jan 2021 08:00:00 -0000

ros-rolling-rcutils (3.0.0-1focal) focal; urgency=high

  * Update rcutils_calculate_directory_size() to support recursion (#306 <https://github.com/ros2/rcutils/issues/306>)
  * Updating QD to QL 1 (#317 <https://github.com/ros2/rcutils/issues/317>)
  * Address unused return values found in scan-build (#316 <https://github.com/ros2/rcutils/issues/316>)
  * use one copy for continuous area instead of loop copy (#312 <https://github.com/ros2/rcutils/issues/312>)
  * use a better way to check whether string is empty (#315 <https://github.com/ros2/rcutils/issues/315>)
  * Use helper funciton to copy string (#314 <https://github.com/ros2/rcutils/issues/314>)
  * Disable a Windows platform warning. (#311 <https://github.com/ros2/rcutils/issues/311>)
  * Fix format of code description on document (#313 <https://github.com/ros2/rcutils/issues/313>)
  * Make sure to check the return values of rcutils APIs. (#302 <https://github.com/ros2/rcutils/issues/302>)
  * Contributors: Barry Xu, Chen Lihui, Chris Lalancette, Stephen Brawner

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 02 Dec 2020 08:00:00 -0000

ros-rolling-rcutils (2.2.0-1focal) focal; urgency=high

  * Add rcutils_expand_user() to expand user directory in path (#298 <https://github.com/ros2/rcutils/issues/298>)
  * Update the maintainers. (#299 <https://github.com/ros2/rcutils/issues/299>)
  * Remove the temporary variable in RCUTILS_LOGGING_AUTOINIT (#290 <https://github.com/ros2/rcutils/issues/290>)
  * Contributors: Chris Lalancette, Christophe Bedard, Felix Endres

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 19 Oct 2020 07:00:00 -0000

ros-rolling-rcutils (2.1.0-1focal) focal; urgency=high

  * Add RCUTILS_NO_FAULT_INJECTION() macro. (#295 <https://github.com/ros2/rcutils/issues/295>)
  * Inject faults on rcutils_get_env() and rcutils_set_env() call. (#292 <https://github.com/ros2/rcutils/issues/292>)
  * env.h and get_env.h docblock fixes (#291 <https://github.com/ros2/rcutils/issues/291>)
  * Introduce rcutils_strcasecmp, case insensitive string compare. (#280 <https://github.com/ros2/rcutils/issues/280>)
  * Stop using fprintf to avoid using file handles by changing as few lines of code as possible. (#289 <https://github.com/ros2/rcutils/issues/289>)
  * Defines QNX implementation for rcutils_get_platform_library_name (#287 <https://github.com/ros2/rcutils/issues/287>)
  * Contributors: Ahmed Sobhy, Ivan Santiago Paunovic, Michel Hidalgo, tomoya

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 02 Oct 2020 07:00:00 -0000

ros-rolling-rcutils (2.0.0-1focal) focal; urgency=high



=== debian/control ===
Source: ros-rolling-rcutils
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libatomic1, python3-empy, ros-rolling-ament-cmake-gmock, ros-rolling-ament-cmake-gtest, ros-rolling-ament-cmake-pytest, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-launch, ros-rolling-launch-testing, ros-rolling-launch-testing-ament-cmake, ros-rolling-mimick-vendor, ros-rolling-osrf-testing-tools-cpp, ros-rolling-performance-test-fixture, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rcutils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libatomic1, ros-rolling-ros-workspace
Description: Package containing various utility types and functions for C

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rcutils//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rcutils 6.3.1

=== debian/changelog ===
ros-rolling-rcutils (6.3.1-1jammy) jammy; urgency=high

  * Remove unused 'max' functions from sha256.c (#429 <https://github.com/ros2/rcutils/issues/429>)
  * Contributors: Chris Lalancette

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Thu, 07 Sep 2023 00:00:00 -0000

ros-rolling-rcutils (6.3.0-1jammy) jammy; urgency=high



 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Thu, 27 Apr 2023 00:00:00 -0000

ros-rolling-rcutils (6.2.1-1jammy) jammy; urgency=high

  * fix memory leak (#423 <https://github.com/ros2/rcutils/issues/423>)
  * Contributors: Chen Lihui

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Wed, 12 Apr 2023 00:00:00 -0000

ros-rolling-rcutils (6.2.0-1jammy) jammy; urgency=high

  * Add convenience error handling macros (#421 <https://github.com/ros2/rcutils/issues/421>)
  * Calculate the next power-of-two for the user in hash_map_init. (#420 <https://github.com/ros2/rcutils/issues/420>)
  * update cast to modern style (#418 <https://github.com/ros2/rcutils/issues/418>)
  * Remove deprecated header get_env.h (#417 <https://github.com/ros2/rcutils/issues/417>)
  * Updates to rcutils to make rosdoc2 generation happier. (#416 <https://github.com/ros2/rcutils/issues/416>)
  * add RCUTILS_LOGGING_AUTOINIT_WITH_ALLOCATOR. (#415 <https://github.com/ros2/rcutils/issues/415>)
  * Fix memory leak in string_map.c in rcutils (#411 <https://github.com/ros2/rcutils/issues/411>)
  * avoid unnecessary copy for rcutils_char_array_vsprintf. (#412 <https://github.com/ros2/rcutils/issues/412>)
  * Contributors: Chris Lalancette, Emerson Knapp, Mario Prats, Nikolai Morin, Tomoya Fujita, methylDragon

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Tue, 11 Apr 2023 00:00:00 -0000

ros-rolling-rcutils (6.1.1-1jammy) jammy; urgency=high

  * Add missing stddef include for size_t (#410 <https://github.com/ros2/rcutils/issues/410>)
  * Contributors: Emerson Knapp

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Fri, 24 Feb 2023 00:00:00 -0000

ros-rolling-rcutils (6.1.0-1jammy) jammy; urgency=high

  * Add SHA256 utility implementation (#408 <https://github.com/ros2/rcutils/issues/408>)
  * Upgrade rcutils to C++17. (#392 <https://github.com/ros2/rcutils/issues/392>)
  * [rolling] Update maintainers - 2022-11-07 (#404 <https://github.com/ros2/rcutils/issues/404>)
  * Contributors: Audrow Nash, Chris Lalancette, Emerson Knapp

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Mon, 13 Feb 2023 00:00:00 -0000

ros-rolling-rcutils (6.0.1-1jammy) jammy; urgency=high

  * Fix build on OpenHarmony (#395 <https://github.com/ros2/rcutils/issues/395>)
  * regression of thread-safety for logging macros (#393 <https://github.com/ros2/rcutils/issues/393>)
  * add portable nonnull macros (#382 <https://github.com/ros2/rcutils/issues/382>)
  * Fix memory leak when adding the same key to the logger hash map multiple times (#391 <https://github.com/ros2/rcutils/issues/391>)
  * time_unix: uses ZEPHYR_VERSION_CODE instead (#390 <https://github.com/ros2/rcutils/issues/390>)
  * Cleanup time_unix.c (#389 <https://github.com/ros2/rcutils/issues/389>)
  * time_unix: namespace zephyr headers (#383 <https://github.com/ros2/rcutils/issues/383>)
  * Restrict overmatching MACH ifdef to only trigger on OSX and Mach (#386 <https://github.com/ros2/rcutils/issues/386>)
  * Contributors: AIxWall, Chris Lalancette, Felipe Neves, Jacob Perron, Maximilian Downey Twiss, William Woodall

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Wed, 02 Nov 2022 00:00:00 -0000

ros-rolling-rcutils (6.0.0-1jammy) jammy; urgency=high

  * Optimize rcutils_logging_get_logger_effective_level() (#381 <https://github.com/ros2/rcutils/issues/381>)
  * Change syntax __VAR_ARGS__ to __VA_ARGS__ (#376 <https://github.com/ros2/rcutils/issues/376>)
  * Fix a bug in hash_map_get_next_key_and_data. (#375 <https://github.com/ros2/rcutils/issues/375>)
  * More fixes from review.
  * Fixes from review.
  * Make g_rcutils_logging_output_handler static.
  * Make g_rcutils_logging_default_logger_level static.
  * Optimize rcutils_find_lastn where possible.
  * Don't bother computing the hash_map key if the hash map is empty.
  * Make sure to expand char_array by at least 1.5x.
  * Optimize index computation in hash_map_find.
  * Improve the performance of rcutils_logging_format_message. (#372 <https://github.com/ros2/rcutils/issues/372>)
  * Get rid of unnecessary ret variable.
  * Get rid of unnecessary ifdef cplusplus checks in the C file.
  * Get rid of unnecessary rcutils_custom_add_{gtest,gmock}
  * Get rid of unnecessary and unused RMW switching for logging tests.
  * Remove unnecessary IS_OUTPUT_COLORIZED macro.
  * Rename logging internal structures to use our new convention.
  * Make all of the logging 'expand' methods static.
  * Fix up error checking for RCUTILS_CONSOLE_STDOUT_LINE_BUFFERED.
  * Cleanup error handling for the RCUTILS_CONSOLE_OUTPUT_FORMAT checks.
  * Revamp error handling in rcutils_logging_initialize_with_allocator.
  * Revamp rcutils_logging_initialize_with_allocator.
  * Make a few logging global variables static.
  * Optimize calls via the RCUTILS_LOG macros. (#369 <https://github.com/ros2/rcutils/issues/369>)
  * time_unix: add zephyr posix time (#368 <https://github.com/ros2/rcutils/issues/368>)
  * Optimize the implementation of rcutils_char_array_strncpy. (#367 <https://github.com/ros2/rcutils/issues/367>)
  * strdup.c: fix arbitrary length overread (#366 <https://github.com/ros2/rcutils/issues/366>)
  * Mirror rolling to master
  * strdup.c: fix 1 byte buffer overread (#363 <https://github.com/ros2/rcutils/issues/363>)
  * Clarify duration arg description in logging macros (#359 <https://github.com/ros2/rcutils/issues/359>)
  * Contributors: Abrar Rahman Protyasha, Audrow Nash, Chris Lalancette, Felipe Neves, Yakumoo, guijan

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Tue, 13 Sep 2022 00:00:00 -0000



=== debian/control ===
Source: ros-rolling-rcutils
Section: misc
Priority: optional
Maintainer: Alejandro Hernandez Cordero <alejandro@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libatomic1, python3-empy, ros-rolling-ament-cmake-gmock <!nocheck>, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-cmake-pytest <!nocheck>, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-launch <!nocheck>, ros-rolling-launch-testing <!nocheck>, ros-rolling-launch-testing-ament-cmake <!nocheck>, ros-rolling-mimick-vendor <!nocheck>, ros-rolling-osrf-testing-tools-cpp <!nocheck>, ros-rolling-performance-test-fixture <!nocheck>, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rcutils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libatomic1, ros-rolling-ros-workspace
Description: Package containing various utility types and functions for C

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
